/* www.sgm.siedlce.pl

Monitor pakietu LiPo 1S-3S z sygnalizacja spadku napiecia
pojedynczej celi ponizej zalozonego progu, wspolpracujacy
z telemetria Fr-Sky (kanaly analogowe A2/A1). Dioda (LED13)
sygnalizuje po podlaczeniu rozpoznana ilosc cel, po
uruchomieniu alarmu zapala sie na stale, jesli nie swieci,
to pakiet (zlacze balancerowe) nie podlaczony, lub podlaczony
nieprawidlowo.
Prog alarmu ustawiany w wierszu deklaracji:
"const float Ua = 3.x;"

Projekt wylacznie do wykorzystania na wlasny uzytek

*/


const int LED = 13;            // LED na Pin 13
const int FRS = 12;            // wyjscie do FR-Sky na Pin 12
byte LCell=0;                  // alarm
byte nCell;                    // ilosc cel
int ReadA1;                    // stan we analog1
int ReadA2;                    // stan we analog2
int ReadA3;                    // stan we analog3

const float Ua = 3.6;          //prog alarmu (3,6V) <-- tu moja wartosc
const int Ref = 5;             //napiecie odniesienia (5V)
const float x1 = 1.97;         //dzielnik celi 1
const float x2 = 2.02;         //dzielnik celi 2
const float x3 = 3.05;         //dzielnik celi 3  (2.96)
const float Vd = 0.63;         //napiecie diody

float Vc1;                     //zmierzone napiecie dzielnika
float Vc2;
float Vc3;

float U1;                      //obliczone napiecie celi
float U2;
float U3;

float U10;                     //tymczasowe do zaokraglen
int Uint;
float Usum;


void setup()
{                
  //Serial.begin(9600);   // do testowania
  pinMode(LED, OUTPUT);
  pinMode(FRS, OUTPUT);
  digitalWrite(LED, LOW);
  digitalWrite(FRS, HIGH);
  
}


void loop()
{                     
 
  ReadA1 = analogRead(1);
  delay(5);
  ReadA2 = analogRead(2);
  delay(5);
  ReadA3 = analogRead(3);
  delay(5);
  
  if (ReadA1 <10){
   nCell=0;
  } else { 
   if (ReadA2 <10){
    nCell=1;
   } else {
    if (ReadA3 <10){
     nCell=2;
    } else {
     nCell=3; 
    }     //if (ReadA3 <10) 
   }      //if (ReadA2 <10) 
  }       //if (ReadA1 <10)
  
  Vc1= Vd + (x1*Ref*ReadA1)/1024;
  Vc2= Vd + (x2*Ref*ReadA2)/1024;
  Vc3= Vd + (x3*Ref*ReadA3)/1024;
   
 switch (nCell) {  
  
  case 0:
    U1=4.2;
    U2=4.2;
    U3=4.2;
    digitalWrite(LED, LOW);
    digitalWrite(FRS, HIGH);
  break; // case 0
  
  case 1:
    U1=Vc1;
    U2=4.2;
    U3=4.2;
   if (LCell==0) { 
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
   } 
  break; // case 1
  
  case 2:
    U1=Vc1;
    U2=Vc2-Vc1;
    U3=4.2; 
   if (LCell==0) {
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
    delay(200);
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
   }
  break; // case 2

  case 3:
    U1=Vc1;
    U2=Vc2-Vc1;
    U3=Vc3-Vc2;
   if (LCell==0) {    
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
    delay(200);
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
    delay(200);
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
   }
  break; // case 3
  
  default: // jesli zadna z powyzszych
  break;   // default
 
 }
 
//zaokraglenia

  U10 = 10*U1;
  Uint = U10;
  if ((U10-Uint)>0.5) {
    U10 = ceil(U10);
  } else {
    U10 = floor(U10);
  }
  U1 = U10/10;
  
  U10 = 10*U2;
  Uint = U10;
  if ((U10-Uint)>0.5) {
    U10 = ceil(U10);
  } else {
    U10 = floor(U10);
  }
  U2 = U10/10;
  
  U10 = 10*U3;
  Uint = U10;
  if ((U10-Uint)>0.5) {
    U10 = ceil(U10);
  } else {
    U10 = floor(U10);
  }
  U3 = U10/10;
  
  Usum=U1+U2+U3;
  
  if ((U1<Ua) || (U2<Ua) || (U3<Ua)) {
   digitalWrite(LED, HIGH);
   digitalWrite(FRS, LOW);           // jest alarm
   delay (500);
   LCell = 1;
  } else { 
   digitalWrite(LED, LOW);
   digitalWrite(FRS, HIGH);
   LCell = 0;
  }  
  
  
  //wydruk zmierzonych wartości napięcia - przydatne
  //do testowania,  
  
  //Serial.println(nCell);
  //Serial.println(U10,3);
  //Serial.println(Uint);
  //Serial.println(Usum);
  /*  
  Serial.print("C1= ;");
  //Serial.print(Vc1,2);
  Serial.print(ReadA1);
  Serial.print("    C2= ;");
  //Serial.print(Vc2,2);
  Serial.print(ReadA2); 
  Serial.print("    C3= ;");
  //Serial.println(Vc3,2);
  Serial.println(ReadA3);

  Serial.print("C1= ;");
  Serial.print(Vc1,2);
  Serial.print("    C2= ;");
  Serial.print(Vc2,2);
  Serial.print("    C3= ;");
  Serial.println(Vc3,2);
  
  Serial.print("U1= ;");
  Serial.print(U1,2);
  Serial.print("    U2= ;");
  Serial.print(U2,2);
  Serial.print("    U3= ;");
  Serial.println(U3,2);
  
  Serial.println();

*/
 
 delay (1500);
 
 
}


